diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.45/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.44/src/wifi/test/wifi-phy-ofdma-test.cc	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-phy-ofdma-test.cc	2025-06-01 20:34:45.641702400 -0700
@@ -3268,114 +3527,158 @@
     phy->Send(psdus, txVector);
 }
 
+template <typename LatestPhyEntityType>
 WifiTxVector
-TestUlOfdmaPhyTransmission::GetTxVectorForHeTbPpdu(uint16_t txStaId,
-                                                   std::size_t index,
-                                                   uint8_t bssColor) const
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::GetTxVectorForTbPpdu(uint16_t txStaId,
+                                                                      std::size_t index,
+                                                                      uint8_t bssColor) const
 {
-    WifiTxVector txVector{HePhy::GetHeMcs7(),
-                          0,
-                          WIFI_PREAMBLE_HE_TB,
-                          NanoSeconds(1600),
-                          1,
-                          1,
-                          0,
-                          m_channelWidth,
-                          false,
-                          false,
-                          false,
-                          bssColor};
-
-    auto ruType = HeRu::RU_106_TONE;
+    WifiTxVector txVector{
+        (m_modClass == WIFI_MOD_CLASS_HE) ? HePhy::GetHeMcs7() : EhtPhy::GetEhtMcs7(),
+        0,
+        (m_modClass == WIFI_MOD_CLASS_HE) ? WIFI_PREAMBLE_HE_TB : WIFI_PREAMBLE_EHT_TB,
+        NanoSeconds(1600),
+        1,
+        1,
+        0,
+        m_channelWidth,
+        false,
+        false,
+        false,
+        bssColor};
+    if (m_modClass == WIFI_MOD_CLASS_EHT)
+    {
+        txVector.SetEhtPpduType(0);
+    }
+    auto ruType{RuType::RU_TYPE_MAX};
     if (m_channelWidth == MHz_u{20})
     {
-        ruType = HeRu::RU_106_TONE;
+        ruType = RuType::RU_106_TONE;
     }
     else if (m_channelWidth == MHz_u{40})
     {
-        ruType = HeRu::RU_242_TONE;
+        ruType = RuType::RU_242_TONE;
     }
     else if (m_channelWidth == MHz_u{80})
     {
-        ruType = HeRu::RU_484_TONE;
+        ruType = RuType::RU_484_TONE;
     }
     else if (m_channelWidth == MHz_u{160})
     {
-        ruType = HeRu::RU_996_TONE;
+        ruType = RuType::RU_996_TONE;
+    }
+    else if (m_channelWidth == MHz_u{320})
+    {
+        ruType = RuType::RU_2x996_TONE;
     }
     else
     {
-        NS_ASSERT_MSG(false, "Unsupported channel width");
+        NS_ASSERT_MSG(false, "Unsupported channel width: " << m_channelWidth);
     }
 
-    auto primary80MHz = true;
-    if (m_channelWidth == MHz_u{160} && index == 2)
+    auto primary80MHzOrLow80MHz{true};
+    auto primary160MHz{true};
+    if (m_channelWidth > MHz_u{80})
     {
-        primary80MHz = false;
-        index = 1;
+        if (m_modClass == WIFI_MOD_CLASS_HE)
+        {
+            primary80MHzOrLow80MHz = HeRu::GetPrimary80MHzFlag(m_channelWidth, ruType, index, 0);
+            index = HeRu::GetIndexIn80MHzSegment(m_channelWidth, ruType, index);
+        }
+        else
+        {
+            const auto& [p160, p80OrLow80] =
+                EhtRu::GetPrimaryFlags(m_channelWidth, ruType, index, 0);
+            primary160MHz = p160;
+            primary80MHzOrLow80MHz = p80OrLow80;
+            index = EhtRu::GetIndexIn80MHzSegment(m_channelWidth, ruType, index);
+        }
     }
-    HeRu::RuSpec ru(ruType, index, primary80MHz);
+    const auto ru =
+        (m_modClass == WIFI_MOD_CLASS_HE)
+            ? WifiRu::RuSpec(HeRu::RuSpec{ruType, index, primary80MHzOrLow80MHz})
+            : WifiRu::RuSpec(EhtRu::RuSpec{ruType, index, primary160MHz, primary80MHzOrLow80MHz});
     txVector.SetRu(ru, txStaId);
-    txVector.SetMode(HePhy::GetHeMcs7(), txStaId);
+    txVector.SetMode((m_modClass == WIFI_MOD_CLASS_HE) ? HePhy::GetHeMcs7() : EhtPhy::GetEhtMcs7(),
+                     txStaId);
     txVector.SetNss(1, txStaId);
     return txVector;
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::SetTrigVector(uint8_t bssColor, TrigVectorInfo error)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SetTrigVector(uint8_t bssColor,
+                                                               TrigVectorInfo error)
 {
     auto channelWidth = m_channelWidth;
     if (error == CHANNEL_WIDTH)
     {
-        channelWidth = (channelWidth == MHz_u{160} ? MHz_u{20} : channelWidth * 2);
+        channelWidth =
+            (channelWidth >= GetMaximumChannelWidth(m_modClass) ? MHz_u{20} : channelWidth * 2);
     }
 
-    WifiTxVector txVector(HePhy::GetHeMcs7(),
-                          0,
-                          WIFI_PREAMBLE_HE_TB,
-                          NanoSeconds(1600),
-                          1,
-                          1,
-                          0,
-                          channelWidth,
-                          false,
-                          false,
-                          false,
-                          bssColor);
+    WifiTxVector txVector(
+        (m_modClass == WIFI_MOD_CLASS_HE) ? HePhy::GetHeMcs7() : EhtPhy::GetEhtMcs7(),
+        0,
+        (m_modClass == WIFI_MOD_CLASS_HE) ? WIFI_PREAMBLE_HE_TB : WIFI_PREAMBLE_EHT_TB,
+        NanoSeconds(1600),
+        1,
+        1,
+        0,
+        channelWidth,
+        false,
+        false,
+        false,
+        bssColor);
 
-    HeRu::RuType ruType = HeRu::RU_106_TONE;
+    RuType ruType = RuType::RU_106_TONE;
     if (channelWidth == MHz_u{20})
     {
-        ruType = HeRu::RU_106_TONE;
+        ruType = RuType::RU_106_TONE;
     }
     else if (channelWidth == MHz_u{40})
     {
-        ruType = HeRu::RU_242_TONE;
+        ruType = RuType::RU_242_TONE;
     }
     else if (channelWidth == MHz_u{80})
     {
-        ruType = HeRu::RU_484_TONE;
+        ruType = RuType::RU_484_TONE;
     }
     else if (channelWidth == MHz_u{160})
     {
-        ruType = HeRu::RU_996_TONE;
+        ruType = RuType::RU_996_TONE;
+    }
+    else if (channelWidth == MHz_u{320})
+    {
+        ruType = RuType::RU_2x996_TONE;
     }
     else
     {
-        NS_ASSERT_MSG(false, "Unsupported channel width");
+        NS_ASSERT_MSG(false, "Unsupported channel width: " << channelWidth);
     }
 
     uint16_t aid1 = (error == AID ? 3 : 1);
     uint16_t aid2 = (error == AID ? 4 : 2);
 
-    HeRu::RuSpec ru1(ruType, 1, true);
+    const auto ru1 = (m_modClass == WIFI_MOD_CLASS_HE)
+                         ? WifiRu::RuSpec(HeRu::RuSpec{ruType, 1, true})
+                         : WifiRu::RuSpec(EhtRu::RuSpec{ruType, 1, true, true});
     txVector.SetRu(ru1, aid1);
-    txVector.SetMode(HePhy::GetHeMcs7(), aid1);
+    txVector.SetMode((m_modClass == WIFI_MOD_CLASS_HE) ? HePhy::GetHeMcs7() : EhtPhy::GetEhtMcs7(),
+                     aid1);
     txVector.SetNss(1, aid1);
 
-    HeRu::RuSpec ru2(ruType, (channelWidth == MHz_u{160} ? 1 : 2), (channelWidth != MHz_u{160}));
+    const auto ru2 = (m_modClass == WIFI_MOD_CLASS_HE)
+                         ? WifiRu::RuSpec(HeRu::RuSpec{ruType,
+                                                       (channelWidth == MHz_u{160} ? 1ULL : 2ULL),
+                                                       (channelWidth != MHz_u{160})})
+                         : WifiRu::RuSpec(EhtRu::RuSpec{ruType,
+                                                        (channelWidth == MHz_u{320} ? 1ULL : 2ULL),
+                                                        (channelWidth != MHz_u{320}),
+                                                        true});
     txVector.SetRu(ru2, aid2);
-    txVector.SetMode(HePhy::GetHeMcs7(), aid2);
+    txVector.SetMode((m_modClass == WIFI_MOD_CLASS_HE) ? HePhy::GetHeMcs7() : EhtPhy::GetEhtMcs7(),
+                     aid2);
     txVector.SetNss(1, aid2);
 
     uint16_t length;
@@ -3388,17 +3691,18 @@
         ++length;
     }
     txVector.SetLength(length);
-    auto hePhyAp = DynamicCast<HePhy>(m_phyAp->GetLatestPhyEntity());
-    hePhyAp->SetTrigVector(txVector, m_expectedPpduDuration);
+    auto phyAp = m_phyAp->GetPhyEntity();
+    phyAp->SetTrigVector(txVector, m_expectedPpduDuration);
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::SendHeTbPpdu(uint16_t txStaId,
-                                         std::size_t index,
-                                         std::size_t payloadSize,
-                                         uint64_t uid,
-                                         uint8_t bssColor,
-                                         bool incrementUid)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SendTbPpdu(uint16_t txStaId,
+                                                            std::size_t index,
+                                                            std::size_t payloadSize,
+                                                            uint64_t uid,
+                                                            uint8_t bssColor,
+                                                            bool incrementUid)
 {
     NS_LOG_FUNCTION(this << txStaId << index << payloadSize << uid << +bssColor << (incrementUid));
     WifiConstPsduMap psdus;
@@ -3408,7 +3712,7 @@
         ++uid;
     }
 
-    WifiTxVector txVector = GetTxVectorForHeTbPpdu(txStaId, index, bssColor);
+    auto txVector = GetTxVectorForTbPpdu(txStaId, index, bssColor);
     Ptr<Packet> pkt = Create<Packet>(payloadSize);
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_QOSDATA);
@@ -3421,7 +3725,7 @@
     Ptr<WifiPsdu> psdu = Create<WifiPsdu>(pkt, hdr);
     psdus.insert(std::make_pair(txStaId, psdu));
 
-    Ptr<OfdmaSpectrumWifiPhy> phy;
+    Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> phy;
     if (txStaId == 1)
     {
         phy = m_phySta1;
@@ -3435,10 +3739,11 @@
         phy = m_phySta3;
     }
 
-    Time txDuration = OfdmaSpectrumWifiPhy::CalculateTxDuration(psdu->GetSize(),
-                                                                txVector,
-                                                                phy->GetPhyBand(),
-                                                                txStaId);
+    Time txDuration =
+        OfdmaSpectrumWifiPhy<LatestPhyEntityType>::CalculateTxDuration(psdu->GetSize(),
+                                                                       txVector,
+                                                                       phy->GetPhyBand(),
+                                                                       txStaId);
     txVector.SetLength(
         HePhy::ConvertHeTbPpduDurationToLSigLength(txDuration, txVector, phy->GetPhyBand()).first);
 
@@ -3446,31 +3751,35 @@
     phy->Send(psdus, txVector);
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::GenerateInterference(Ptr<SpectrumValue> interferencePsd, Time duration)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::GenerateInterference(
+    Ptr<SpectrumValue> interferencePsd,
+    Time duration)
 {
     NS_LOG_FUNCTION(this << duration);
     m_phyInterferer->SetTxPowerSpectralDensity(interferencePsd);
     m_phyInterferer->SetPeriod(duration);
     m_phyInterferer->Start();
-    Simulator::Schedule(duration, &TestUlOfdmaPhyTransmission::StopInterference, this);
+    Simulator::Schedule(duration,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::StopInterference,
+                        this);
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::StopInterference()
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::StopInterference()
 {
     m_phyInterferer->Stop();
 }
 
-TestUlOfdmaPhyTransmission::~TestUlOfdmaPhyTransmission()
-{
-}
-
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::RxSuccess(Ptr<const WifiPsdu> psdu,
-                                      RxSignalInfo rxSignalInfo,
-                                      const WifiTxVector& txVector,
-                                      const std::vector<bool>& /*statusPerMpdu*/)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::RxSuccess(
+    Ptr<const WifiPsdu> psdu,
+    RxSignalInfo rxSignalInfo,
+    const WifiTxVector& txVector,
+    const std::vector<bool>& /*statusPerMpdu*/)
 {
     NS_LOG_FUNCTION(this << *psdu << psdu->GetAddr2() << rxSignalInfo << txVector);
     if (psdu->GetAddr2() == Mac48Address("00:00:00:00:00:01"))
@@ -3485,8 +3794,9 @@
     }
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::RxFailure(Ptr<const WifiPsdu> psdu)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::RxFailure(Ptr<const WifiPsdu> psdu)
 {
     NS_LOG_FUNCTION(this << *psdu << psdu->GetAddr2());
     if (psdu->GetAddr2() == Mac48Address("00:00:00:00:00:01"))
@@ -3499,10 +3809,11 @@
     }
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::CheckRxFromSta1(uint32_t expectedSuccess,
-                                            uint32_t expectedFailures,
-                                            uint32_t expectedBytes)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckRxFromSta1(uint32_t expectedSuccess,
+                                                                 uint32_t expectedFailures,
+                                                                 uint32_t expectedBytes)
 {
     NS_TEST_ASSERT_MSG_EQ(m_countRxSuccessFromSta1,
                           expectedSuccess,
@@ -3510,16 +3821,17 @@
     NS_TEST_ASSERT_MSG_EQ(
         m_countRxFailureFromSta1,
         expectedFailures,
-        "The number of unsuccessfuly received packets from STA 1 is not correct!");
+        "The number of unsuccessfully received packets from STA 1 is not correct!");
     NS_TEST_ASSERT_MSG_EQ(m_countRxBytesFromSta1,
                           expectedBytes,
                           "The number of bytes received from STA 1 is not correct!");
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::CheckRxFromSta2(uint32_t expectedSuccess,
-                                            uint32_t expectedFailures,
-                                            uint32_t expectedBytes)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckRxFromSta2(uint32_t expectedSuccess,
+                                                                 uint32_t expectedFailures,
+                                                                 uint32_t expectedBytes)
 {
     NS_TEST_ASSERT_MSG_EQ(m_countRxSuccessFromSta2,
                           expectedSuccess,
@@ -3527,16 +3839,18 @@
     NS_TEST_ASSERT_MSG_EQ(
         m_countRxFailureFromSta2,
         expectedFailures,
-        "The number of unsuccessfuly received packets from STA 2 is not correct!");
+        "The number of unsuccessfully received packets from STA 2 is not correct!");
     NS_TEST_ASSERT_MSG_EQ(m_countRxBytesFromSta2,
                           expectedBytes,
                           "The number of bytes received from STA 2 is not correct!");
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::CheckNonOfdmaRxPower(Ptr<OfdmaSpectrumWifiPhy> phy,
-                                                 WifiSpectrumBandInfo band,
-                                                 Watt_u expectedRxPower)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckNonOfdmaRxPower(
+    Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> phy,
+    WifiSpectrumBandInfo band,
+    Watt_u expectedRxPower)
 {
     auto event = phy->GetCurrentEvent();
     NS_ASSERT(event);
@@ -3551,10 +3865,12 @@
                                           << " at " << Simulator::Now());
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::CheckOfdmaRxPower(Ptr<OfdmaSpectrumWifiPhy> phy,
-                                              WifiSpectrumBandInfo band,
-                                              Watt_u expectedRxPower)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckOfdmaRxPower(
+    Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> phy,
+    WifiSpectrumBandInfo band,
+    Watt_u expectedRxPower)
 {
     /**
      * The current event cannot be used since it points to the preamble part of the HE TB PPDU.
@@ -3586,8 +3902,9 @@
     }
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::VerifyEventsCleared()
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::VerifyEventsCleared()
 {
     NS_TEST_ASSERT_MSG_EQ(m_phyAp->GetCurrentEvent(),
                           nullptr,
@@ -3600,17 +3917,25 @@
                           "m_currentEvent for STA 2 was not cleared");
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::CheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckPhyState(
+    Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> phy,
+    WifiPhyState expectedState)
 {
     // This is needed to make sure PHY state will be checked as the last event if a state change
     // occurred at the exact same time as the check
-    Simulator::ScheduleNow(&TestUlOfdmaPhyTransmission::DoCheckPhyState, this, phy, expectedState);
+    Simulator::ScheduleNow(&TestUlOfdmaPhyTransmission<LatestPhyEntityType>::DoCheckPhyState,
+                           this,
+                           phy,
+                           expectedState);
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::DoCheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy,
-                                            WifiPhyState expectedState)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::DoCheckPhyState(
+    Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> phy,
+    WifiPhyState expectedState)
 {
     WifiPhyState currentState;
     PointerValue ptr;
@@ -3624,9 +3949,10 @@
                                        << expectedState << " at " << Simulator::Now());
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::CheckApRxStart(uint32_t expectedNotifications,
-                                           Time expectedLastNotification)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckApRxStart(uint32_t expectedNotifications,
+                                                                Time expectedLastNotification)
 {
     NS_TEST_ASSERT_MSG_EQ(m_apPhyStateListener->GetNumRxStartNotifications(),
                           expectedNotifications,
@@ -3642,10 +3968,11 @@
                               << " for AP at " << Simulator::Now());
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::CheckApRxEnd(uint32_t expectedNotifications,
-                                         Time expectedLastNotification,
-                                         bool expectedSuccess)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckApRxEnd(uint32_t expectedNotifications,
+                                                              Time expectedLastNotification,
+                                                              bool expectedSuccess)
 {
     NS_TEST_ASSERT_MSG_EQ(m_apPhyStateListener->GetNumRxEndNotifications(),
                           expectedNotifications,
@@ -3667,8 +3994,9 @@
                               << " for AP at " << Simulator::Now());
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::Reset()
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::Reset()
 {
     m_countRxSuccessFromSta1 = 0;
     m_countRxSuccessFromSta2 = 0;
@@ -3683,24 +4011,31 @@
     m_apPhyStateListener->Reset();
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::SetBssColor(Ptr<WifiPhy> phy, uint8_t bssColor)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SetBssColor(Ptr<WifiPhy> phy, uint8_t bssColor)
 {
     Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice>(phy->GetDevice());
     Ptr<HeConfiguration> heConfiguration = device->GetHeConfiguration();
-    heConfiguration->SetAttribute("BssColor", UintegerValue(bssColor));
+    heConfiguration->m_bssColor = bssColor;
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::SetPsdLimit(Ptr<WifiPhy> phy, dBm_per_MHz_u psdLimit)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SetPsdLimit(Ptr<WifiPhy> phy,
+                                                             dBm_per_MHz_u psdLimit)
 {
     NS_LOG_FUNCTION(this << phy << psdLimit);
     phy->SetAttribute("PowerDensityLimit", DoubleValue(psdLimit));
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::DoSetup()
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::DoSetup()
 {
+    const auto standard =
+        (m_modClass == WIFI_MOD_CLASS_HE) ? WIFI_STANDARD_80211ax : WIFI_STANDARD_80211be;
+
     Ptr<MultiModelSpectrumChannel> spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
     Ptr<FriisPropagationLossModel> lossModel = CreateObject<FriisPropagationLossModel>();
     lossModel->SetFrequency(m_frequency);
@@ -3719,24 +4054,30 @@
 
     Ptr<Node> apNode = CreateObject<Node>();
     Ptr<WifiNetDevice> apDev = CreateObject<WifiNetDevice>();
-    apDev->SetStandard(WIFI_STANDARD_80211ax);
+    apDev->SetStandard(standard);
     auto apMac = CreateObjectWithAttributes<ApWifiMac>(
         "Txop",
         PointerValue(CreateObjectWithAttributes<Txop>("AcIndex", StringValue("AC_BE_NQOS"))));
     apMac->SetAttribute("BeaconGeneration", BooleanValue(false));
     apDev->SetMac(apMac);
-    m_phyAp = CreateObject<OfdmaSpectrumWifiPhy>(0);
+    m_phyAp = CreateObject<OfdmaSpectrumWifiPhy<LatestPhyEntityType>>(0);
     Ptr<HeConfiguration> heConfiguration = CreateObject<HeConfiguration>();
     apDev->SetHeConfiguration(heConfiguration);
+    if (m_modClass >= WIFI_MOD_CLASS_EHT)
+    {
+        apDev->SetEhtConfiguration(CreateObject<EhtConfiguration>());
+    }
     Ptr<InterferenceHelper> apInterferenceHelper = CreateObject<InterferenceHelper>();
     m_phyAp->SetInterferenceHelper(apInterferenceHelper);
     Ptr<ErrorRateModel> apErrorModel = CreateObject<NistErrorRateModel>();
     m_phyAp->SetErrorRateModel(apErrorModel);
     m_phyAp->SetDevice(apDev);
     m_phyAp->AddChannel(spectrumChannel);
-    m_phyAp->ConfigureStandard(WIFI_STANDARD_80211ax);
-    m_phyAp->SetReceiveOkCallback(MakeCallback(&TestUlOfdmaPhyTransmission::RxSuccess, this));
-    m_phyAp->SetReceiveErrorCallback(MakeCallback(&TestUlOfdmaPhyTransmission::RxFailure, this));
+    m_phyAp->ConfigureStandard(standard);
+    m_phyAp->SetReceiveOkCallback(
+        MakeCallback(&TestUlOfdmaPhyTransmission<LatestPhyEntityType>::RxSuccess, this));
+    m_phyAp->SetReceiveErrorCallback(
+        MakeCallback(&TestUlOfdmaPhyTransmission<LatestPhyEntityType>::RxFailure, this));
     m_phyAp->SetPreambleDetectionModel(preambleDetectionModel);
     Ptr<ConstantPositionMobilityModel> apMobility = CreateObject<ConstantPositionMobilityModel>();
     m_phyAp->SetMobility(apMobility);
@@ -3749,16 +4090,20 @@
 
     Ptr<Node> sta1Node = CreateObject<Node>();
     Ptr<WifiNetDevice> sta1Dev = CreateObject<WifiNetDevice>();
-    sta1Dev->SetStandard(WIFI_STANDARD_80211ax);
+    sta1Dev->SetStandard(standard);
     sta1Dev->SetHeConfiguration(CreateObject<HeConfiguration>());
-    m_phySta1 = CreateObject<OfdmaSpectrumWifiPhy>(1);
+    if (m_modClass >= WIFI_MOD_CLASS_EHT)
+    {
+        sta1Dev->SetEhtConfiguration(CreateObject<EhtConfiguration>());
+    }
+    m_phySta1 = CreateObject<OfdmaSpectrumWifiPhy<LatestPhyEntityType>>(1);
     Ptr<InterferenceHelper> sta1InterferenceHelper = CreateObject<InterferenceHelper>();
     m_phySta1->SetInterferenceHelper(sta1InterferenceHelper);
     Ptr<ErrorRateModel> sta1ErrorModel = CreateObject<NistErrorRateModel>();
     m_phySta1->SetErrorRateModel(sta1ErrorModel);
     m_phySta1->SetDevice(sta1Dev);
     m_phySta1->AddChannel(spectrumChannel);
-    m_phySta1->ConfigureStandard(WIFI_STANDARD_80211ax);
+    m_phySta1->ConfigureStandard(standard);
     m_phySta1->SetPreambleDetectionModel(preambleDetectionModel);
     Ptr<ConstantPositionMobilityModel> sta1Mobility = CreateObject<ConstantPositionMobilityModel>();
     m_phySta1->SetMobility(sta1Mobility);
@@ -3768,16 +4113,20 @@
 
     Ptr<Node> sta2Node = CreateObject<Node>();
     Ptr<WifiNetDevice> sta2Dev = CreateObject<WifiNetDevice>();
-    sta2Dev->SetStandard(WIFI_STANDARD_80211ax);
+    sta2Dev->SetStandard(standard);
     sta2Dev->SetHeConfiguration(CreateObject<HeConfiguration>());
-    m_phySta2 = CreateObject<OfdmaSpectrumWifiPhy>(2);
+    if (m_modClass >= WIFI_MOD_CLASS_EHT)
+    {
+        sta2Dev->SetEhtConfiguration(CreateObject<EhtConfiguration>());
+    }
+    m_phySta2 = CreateObject<OfdmaSpectrumWifiPhy<LatestPhyEntityType>>(2);
     Ptr<InterferenceHelper> sta2InterferenceHelper = CreateObject<InterferenceHelper>();
     m_phySta2->SetInterferenceHelper(sta2InterferenceHelper);
     Ptr<ErrorRateModel> sta2ErrorModel = CreateObject<NistErrorRateModel>();
     m_phySta2->SetErrorRateModel(sta2ErrorModel);
     m_phySta2->SetDevice(sta2Dev);
     m_phySta2->AddChannel(spectrumChannel);
-    m_phySta2->ConfigureStandard(WIFI_STANDARD_80211ax);
+    m_phySta2->ConfigureStandard(standard);
     m_phySta2->SetPreambleDetectionModel(preambleDetectionModel);
     Ptr<ConstantPositionMobilityModel> sta2Mobility = CreateObject<ConstantPositionMobilityModel>();
     m_phySta2->SetMobility(sta2Mobility);
@@ -3787,16 +4136,20 @@
 
     Ptr<Node> sta3Node = CreateObject<Node>();
     Ptr<WifiNetDevice> sta3Dev = CreateObject<WifiNetDevice>();
-    sta3Dev->SetStandard(WIFI_STANDARD_80211ax);
+    sta3Dev->SetStandard(standard);
     sta3Dev->SetHeConfiguration(CreateObject<HeConfiguration>());
-    m_phySta3 = CreateObject<OfdmaSpectrumWifiPhy>(3);
+    if (m_modClass >= WIFI_MOD_CLASS_EHT)
+    {
+        sta3Dev->SetEhtConfiguration(CreateObject<EhtConfiguration>());
+    }
+    m_phySta3 = CreateObject<OfdmaSpectrumWifiPhy<LatestPhyEntityType>>(3);
     Ptr<InterferenceHelper> sta3InterferenceHelper = CreateObject<InterferenceHelper>();
     m_phySta3->SetInterferenceHelper(sta3InterferenceHelper);
     Ptr<ErrorRateModel> sta3ErrorModel = CreateObject<NistErrorRateModel>();
     m_phySta3->SetErrorRateModel(sta3ErrorModel);
     m_phySta3->SetDevice(sta3Dev);
     m_phySta3->AddChannel(spectrumChannel);
-    m_phySta3->ConfigureStandard(WIFI_STANDARD_80211ax);
+    m_phySta3->ConfigureStandard(standard);
     m_phySta3->SetPreambleDetectionModel(preambleDetectionModel);
     Ptr<ConstantPositionMobilityModel> sta3Mobility = CreateObject<ConstantPositionMobilityModel>();
     m_phySta3->SetMobility(sta3Mobility);
@@ -3828,8 +4181,9 @@
     }
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::DoTeardown()
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::DoTeardown()
 {
     m_phyAp->Dispose();
     m_phyAp = nullptr;
@@ -3843,32 +4197,34 @@
     m_phyInterferer = nullptr;
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::LogScenario(std::string log) const
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::LogScenario(std::string log) const
 {
     NS_LOG_INFO(log);
 }
 
+template <typename LatestPhyEntityType>
 void
-TestUlOfdmaPhyTransmission::ScheduleTest(Time delay,
-                                         bool solicited,
-                                         WifiPhyState expectedStateAtEnd,
-                                         uint32_t expectedSuccessFromSta1,
-                                         uint32_t expectedFailuresFromSta1,
-                                         uint32_t expectedBytesFromSta1,
-                                         uint32_t expectedSuccessFromSta2,
-                                         uint32_t expectedFailuresFromSta2,
-                                         uint32_t expectedBytesFromSta2,
-                                         bool scheduleTxSta1,
-                                         Time ulTimeDifference,
-                                         WifiPhyState expectedStateBeforeEnd,
-                                         TrigVectorInfo error)
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::ScheduleTest(Time delay,
+                                                              bool solicited,
+                                                              WifiPhyState expectedStateAtEnd,
+                                                              uint32_t expectedSuccessFromSta1,
+                                                              uint32_t expectedFailuresFromSta1,
+                                                              uint32_t expectedBytesFromSta1,
+                                                              uint32_t expectedSuccessFromSta2,
+                                                              uint32_t expectedFailuresFromSta2,
+                                                              uint32_t expectedBytesFromSta2,
+                                                              bool scheduleTxSta1,
+                                                              Time ulTimeDifference,
+                                                              WifiPhyState expectedStateBeforeEnd,
+                                                              TrigVectorInfo error)
 {
     static uint64_t uid = 0;
 
     // AP sends an SU packet preceding HE TB PPDUs
     Simulator::Schedule(delay - MilliSeconds(10),
-                        &TestUlOfdmaPhyTransmission::SendHeSuPpdu,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SendSuPpdu,
                         this,
                         0,
                         50,
@@ -3881,7 +4237,11 @@
     }
     else
     {
-        Simulator::Schedule(delay, &TestUlOfdmaPhyTransmission::SetTrigVector, this, 0, error);
+        Simulator::Schedule(delay,
+                            &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SetTrigVector,
+                            this,
+                            0,
+                            error);
     }
     // STA1 and STA2 send MU UL PPDUs addressed to AP
     Simulator::Schedule(delay - MilliSeconds(1),
@@ -3890,7 +4250,7 @@
     if (scheduleTxSta1)
     {
         Simulator::Schedule(delay,
-                            &TestUlOfdmaPhyTransmission::SendHeTbPpdu,
+                            &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SendTbPpdu,
                             this,
                             1,
                             1,
@@ -3900,7 +4260,7 @@
                             false);
     }
     Simulator::Schedule(delay + ulTimeDifference,
-                        &TestUlOfdmaPhyTransmission::SendHeTbPpdu,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SendTbPpdu,
                         this,
                         2,
                         2,
@@ -3911,12 +4271,12 @@
 
     // Verify it takes m_expectedPpduDuration to transmit the PPDUs
     Simulator::Schedule(delay + m_expectedPpduDuration - NanoSeconds(1),
-                        &TestUlOfdmaPhyTransmission::CheckPhyState,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckPhyState,
                         this,
                         m_phyAp,
                         expectedStateBeforeEnd);
     Simulator::Schedule(delay + m_expectedPpduDuration + ulTimeDifference,
-                        &TestUlOfdmaPhyTransmission::CheckPhyState,
+                        &TestUlOfdmaPhyTransmission<LatestPhyEntityType>::CheckPhyState,
                         this,
                         m_phyAp,
                         expectedStateAtEnd);
